#include <depsets.h>
#include <string.h>
/*
 * cmssystem(s1,i,s2) - System call with control over type of call.
 */

FncDcl(cmssystem,3)
   {
   char sbuf[MaxCvtLen];
   char sbuf2[MaxCvtLen];
   char prefix[9];
   char saveprefix[9];
   char *s;
   int  saveccode;
   int  i;
   long ccode;
   char *systemstring;
   char *prefixstring;

   /*
    * Make a C-style string out of Arg1
    */
   switch (cvstr(&Arg1, sbuf)) {

      case Cvt:   /* Already converted to a C-style string */
         break;

      case NoCvt:
         qtos(&Arg1, sbuf);
         break;

      default:
         RunErr(103, &Arg1);
      }
      if (cvint(&Arg2, &ccode) == CvtFail)
         RunErr(101,&Arg2);
   /*
    * Make a C-style string out of Arg3
    */
   switch (cvstr(&Arg3,sbuf2)) {

      case Cvt:   /* Already converted to a C-style string */
         break;

      case NoCvt:
         qtos(&Arg3,sbuf2);
         break;

      default:
         RunErr(103, &Arg2);
      }
      systemstring = StrLoc(Arg3);

   /*
    * Pass the C string to the system() function and return the exit code
    *  of the command as the result of system().
    */

   prefixstring = StrLoc(Arg1);
   for(i=0;i<8;i++) prefix[i] = ' ';
   for(i=0;i<8 && *prefixstring; i++)
       prefix[i] = *prefixstring++;
   prefixstring = prefix;
   prefix[8] = '\0';
   s = setsystem((int)ccode,prefixstring,&saveccode);
   strcpy(saveprefix,s);
   MakeInt((long)system(systemstring), &Arg0);
   s = saveprefix;
   setsystem(saveccode,s,NULL);
   Return;
}
